/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * /builds/slave/mozilla-central-macosx-xulrunner/build/toolkit/components/passwordmgr/public/nsILoginMetaInfo.idl
 */

package org.mozilla.interfaces;

/**
 * An object containing metainfo for a login stored by the login manager.
 *
 * Code using login manager can generally ignore this interface. When adding
 * logins, default value will be created. When modifying logins, these
 * properties will be unchanged unless a change is explicitly requested [by
 * using modifyLogin() with a nsIPropertyBag]. When deleting a login or
 * comparing logins, these properties are ignored.
 */
public interface nsILoginMetaInfo extends nsISupports {

  String NS_ILOGINMETAINFO_IID =
    "{20d8eb40-c494-497f-b2a6-aaa32f807ebd}";

  /**
     * The GUID to uniquely identify the login. This can be any arbitrary
     * string, but a format as created by nsIUUIDGenerator is recommended.
     * For example, "{d4e1a1f6-5ea0-40ee-bff5-da57982f21cf}"
     *
     * addLogin will generate a random value unless a value is provided.
     *
     * addLogin and modifyLogin will throw if the GUID already exists.
     */
  String getGuid();

  /**
     * The GUID to uniquely identify the login. This can be any arbitrary
     * string, but a format as created by nsIUUIDGenerator is recommended.
     * For example, "{d4e1a1f6-5ea0-40ee-bff5-da57982f21cf}"
     *
     * addLogin will generate a random value unless a value is provided.
     *
     * addLogin and modifyLogin will throw if the GUID already exists.
     */
  void setGuid(String aGuid);

  /**
     * The time, in Unix Epoch milliseconds, when the login was first created.
     */
  double getTimeCreated();

  /**
     * The time, in Unix Epoch milliseconds, when the login was first created.
     */
  void setTimeCreated(double aTimeCreated);

  /**
     * The time, in Unix Epoch milliseconds, when the login was last submitted
     * in a form or used to begin an HTTP auth session.
     */
  double getTimeLastUsed();

  /**
     * The time, in Unix Epoch milliseconds, when the login was last submitted
     * in a form or used to begin an HTTP auth session.
     */
  void setTimeLastUsed(double aTimeLastUsed);

  /**
     * The time, in Unix Epoch milliseconds, when the login's password was
     * last modified.
     */
  double getTimePasswordChanged();

  /**
     * The time, in Unix Epoch milliseconds, when the login's password was
     * last modified.
     */
  void setTimePasswordChanged(double aTimePasswordChanged);

  /**
     * The number of times the login was submitted in a form or used to begin
     * an HTTP auth session.
     */
  long getTimesUsed();

  /**
     * The number of times the login was submitted in a form or used to begin
     * an HTTP auth session.
     */
  void setTimesUsed(long aTimesUsed);

}